/* SET MAXIMUMS HERE!! ------------------------------ */
#define MAX_SERVERS 8      /* max. number of servers for a facility */
#define MAX_FACILITIES 500 /* max. number of facilities */
#define MAX_NUM_ATTR 5     /* max. number of attributes for an entity */
#define HEAP_SIZE 50000    /* max. heap size */
/* SET MAXIMUMS HERE!! ------------------------------ */

#define NIL 0 
#define FREE 0 
#define BUSY 1 
#define ON 1
#define OFF 0
#define FOUND 1
#define NOT_FOUND -1
#define TIME_KEY 0
#define AHEAD_PRIORITY_KEY 1
#define BEHIND_PRIORITY_KEY 2
#define INTERACTIVE 0
#define BATCH 1
#define LINKED 0
#define HEAP 1
#define RESEED 32

typedef unsigned long TIME;
typedef unsigned long ADDR;

typedef struct {
  ADDR attr[MAX_NUM_ATTR];
} TOKEN;

TIME current_time, sim_time(), busy_time();
int init_simpack(), end_simpack();
int update_arrivals(), update_completions();
int facility_status(), facility_qsize(), create_facility();
int schedule(), next_event();
int request(), release();
int trace_eventlist(),  trace_eventlist_size(), trace_facility();
int trace_visual();
int report_stats();

#ifdef INCLUDE_RANDOM
/* Declarations for random distribution sampling */
int random_gen();
extern double ranf(), uniform(), expntl(), erlang(), hyperx(), normal();
extern double triang();
extern long seed();
#endif
